.186
;---------------------------------------------------------------------------
;    CBUSLDR.S  C-BUS boot ROM loader (C)2021 ܂(DOSsoft) Version 3.00
;---------------------------------------------------------------------------
;       boX{[hROMp̃wb_̃\[XvO
code            segment
                assume cs:code,ds:code,es:code,ss:code
                org    0                ; I
start:          db      0CBh, 90h, 90h
                db      0CBh, 90h, 90h
                db      0CBh, 90h, 90h  ;                  ** bx bx+1
                db       55h,0AAh, 07h  ; C BUS ROM ID =  07,C7,87
                org  0Ch
                JMP     ROM_entry1
                nop
                org  0Fh
                RETF
                nop
                nop
                org  12h
                RETF
                nop
                nop

                org  15h
                db      0CBh, 90h, 90h
                org  18h
                db      0CBh, 90h, 90h, 0CBh, 90h, 90h
                db      0CBh, 90h, 90h, 0CBh, 90h, 90h, 0CBh, 90h, 90h
                db      0CBh, 90h, 90h, 0CBh, 90h, 90h, 0CBh, 90h, 90h
.386

ROM_entry1:     mov     byte ptr ds:[bx],0C7h  ; 0C7h ; ROM pruducts and type
                pushf
                pushad
                push    ds
                push    es

                mov     es,cs:seg_position
                mov     si,offset COM_PROGRAM_START
                mov     di,00F8h        ; DS:SI --> 7000(ES):00F0h
                xor     eax,eax         ; 386
                mov     ax,cs
                stosd   ;       [F8h]=cs,[FAh]=0000  386
                mov     eax,0CB0001E8h  ;  CALL 100hRETF ߃R[h
                stosd   ;       [FCh]=instruction  ; 386

                push    cs
                pop     ds              ; ds=cs, es=7000h
                mov     cx,1000h        ; 8KB ROMł2000h, 4KBł1000h
                sub     cx, offset COM_PROGRAM_START    ;(7000h)
        rep     movsb                   ; cs --> es
                mov     es:[00F4h],ds   ; save the original values.
                mov     es:[00F6h],es   ;   of the segment register.
; X^bNؑ
                mov     es:[00F0h],ss   ; stack pointer̋Lꏊ
                mov     es:[00F2h],sp
                cli
                mov     ax,es           ; es=7000h
                mov     ds,ax           ; ds=7000h (new segment)
                mov     ss,ax
                mov     sp,0FF00h       ; save stack pointer
                sti

                ;   call far [7000:00FC]
                DB      9Ah
ofs_position    DW      00FCh
seg_position    DW      7000h           ; 7000:00FCh ̐ΔԒnfarR[

; X^bN߂
                cli
                mov     es,cs:seg_position      ; es=7000h (original segment)
                mov     sp,es:[00F2h]   ; restore stack pointer
                mov     ss,es:[00F0h]
                sti

                pop     es
                pop     ds
                popad
                popf
                RETF
;                 DB      "LOADERI"
;align 16

COM_PROGRAM_START       label   byte    ; RRROMCOMvOn܂

code    ends
        end     start
