Xa7C_patch      PROC    near
                cld
; Func_A
                mov     si,offset CodePtnA1
                mov     cx,offset CodePtnA1_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
                mov     di,bx
                mov     si,offset PatPtnA1
           rep  movsb

                mov     si,offset CodePtnA2
                mov     cx,offset CodePtnA2_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
                mov     di,bx
                mov     si,offset PatPtnA2
           rep  movsb

; Func_B
                mov     si,offset CodePtnB_Xa
                mov     cx,offset CodePtnB_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
                mov     di,bx
                mov     si,offset PatPtnB_Xa
           rep  movsb

; Func_S
                mov     si,offset CodePtnS_Xa
                mov     cx,offset CodePtnS_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
                mov     di,bx
                mov     si,offset PatPtnS
           rep  movsb

; Func_DA (sub)
                mov     si,offset space_otesu
                mov     cx,offset space_otesu_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
;                mov     si,offset space48
;                mov     cx,offset space48_end
;                call    scan_pattern    
                mov     bx,10A0h  ; bank3 ;   jc BIOS_not_Xa7C
;        @@: 
                mov     di,bx
                mov     cx,( offset FUNC_DA_part_end  - offset FUNC_DA_part)
                mov     si,offset FUNC_DA_part
           rep  movsb
                mov     si,offset call_st_DA_XA7  
                mov     ds:[si],bx
; Func_DA (main)
                mov     si,offset CodePtnDA_Xa7
                mov     cx,offset CodePtnDA_Xa7_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
                mov     di,bx
                mov     si,offset PatPtnDA_Xa7
           rep  movsb
;-----------
; Func_w (sub)
                mov     si,offset space_conner
                mov     cx,offset space_conner_end
                call    scan_pattern
                jnc     @f
                mov     si,offset space44
                mov     cx,offset space44_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
        @@:
                mov     cx,( offset Func_W_part_end - offset Func_W_part)
                mov     si,offset Func_W_part
                mov     di,bx
           rep  movsb
                mov     si,offset call_st_W
                mov     ds:[si],bx

; Func_w (main)
                mov     si,offset CodePtnW_Xa
                mov     cx,offset CodePtnW_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa7C
                mov     di,bx
                mov     si,offset PatPtnW_Xa
           rep  movsb   
           
                mov     di,1BFAh+1
                mov     ax,0EB4Bh
                stosw
           
                mov     OldPCIPC,0FFh          ; TTY014-VAZ019
                clc
                ret
BIOS_not_Xa7C:
                stc
                ret
Xa7C_patch     ENDP

;===========================================================



;-----------------------------------------------------------

;-----------------------------------------------------------
;       Xa7/C Xa9/C Xa10/C BIOS TTY06E,VAZ06E,VER01F,,,
;-----------------------------------------------------------
CodePtnDA_Xa7   label   byte            ; TTY,VAZ,VER
                mov     dx,[bp+06h]
                mov     ax,[bp+04h]
                test    byte ptr es:[207Bh],80h
                jz      OFFSET_IF_LBA_XA7
                push    cx
                mov     ax,0088h
                mul     word ptr [bp+04h]  ; cyl
                push    ax
                mov     ax,0011h
                mul     byte ptr [bp+07h]
                mov     cx,ax
                pop     ax
                clc
                add     ax,cx
                DB      0E9h,0A8h,14h   ;      jmp   to  1BED - from 0742 
                nop
OFFSET_IF_LBA_XA7:  
                push    cx
                mov     cx,0088h
                div     cx
                mov     es:[2002h],ax
                mov     cx,0011h
                mov     ax,dx
                xor     dx,dx
                div     cx
                and     byte ptr es:[2004h],0F0h
                or      es:[2004h],al
                inc     dl
                mov     es:[2005h],dl
                pop     cx
                mov     es:[200Ah],cl
                ret     
CodePtnDA_Xa7_end label   byte

PatPtnDA_Xa7    label   byte 
                mov     dx,[bp+06h]
                mov     ax,[bp+04h]
                test    byte ptr es:[207Bh],80h
                jz      OFFSET_IF_LBA_P_XA7
                push    cx
                mov     ax,es:HS_VALUE
                mul     word ptr [bp+04h]  ; cyl
                push    ax
                mov     ax,es:SECT_COUNT
                mul     byte ptr [bp+07h]
                mov     cx,ax
                pop     ax
                clc
                add     ax,cx
                DB      0E9h,0A6h,14h   ;    ==>  JMP   1BED - 0744
                nop
OFFSET_IF_LBA_P_XA7:
                push    cx
                mov     cx,es:HS_VALUE
                div     cx

                DB      9Ah
call_st_DA_XA7  label   word
                DW      3333h
                DW      0D800h
                xor     dx,dx
                div     cx
                and     byte ptr es:[2004h],0F0h
                or      es:[2004h],al
                inc     dl
                mov     es:[2005h],dl
                pop     cx
                mov     es:[200Ah],cl
                ret     
;;;                DW      0,0,0
PatPtnDA_Xa7_end label   byte
;-------------------------------

