;--------------------------------------------------------
;       CheckCF4351     ; 4351MB CF[h̃`FbN
;--------------------------------------------------------
CheckCF4351     PROC   near
                mov     dx,offset msg_CF4351_HDD
                in      al,31h          ; DIP SW2-2 
                test    al,00000010b
                jnz     @f
                mov     dx,offset msg_CF4351
        @@:     call    _puts                   ; ̕\
                ret
msg_CF4351      DB      0E1h,"4.3GBCF lCeBu[h",13,10,0
msg_CF4351_HDD  DB      0E1h," ",13,10,0
CheckCF4351     ENDP
;--------------------------------------------------------
;       SetParaMode     
;--------------------------------------------------------
SetParaMode     PROC    near
                mov     di, offset BIOS_ParamTable     ; ̕ϐ̃ItZbg
                sub     di,2000h      ; bx=4c          ; 2000hȂ̂
                mov     ax,offset patch_program_base   ; ̃vO
                add     di,ax                          ; ItZbgɏC
                mov     cx,16/2         ; p[^e[ũ[h
                mov     al,ModeID       ; p[^[h̐̒l
                mov     ah,0
                or      ax,ax           ; [̂Ƃ
                jz      @@keep_table    ; ȂɂȂŖ߂
                cmp     al,7            ; 7ȏ̂Ƃ͂
                jae     @@keep_table    ; ȂɂȂŖ߂
                dec     ax
                shl     ax,4    ; 16oCgԊuȂ̂ŁA[h̒l16{
                mov     si, offset ParamTable_01
                add     si,ax   
                push    es
                push    ds
                pop     es      ; es==ds
           rep  movsw
                pop     es
@@keep_table:   ret

ParamTable_01   label   byte                ;[h
                DW      0811h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      10FFh  ; < 61440MB
                DW      10FFh  ; < 64GB
                DW      10FFh  ; < 122GB
                DW      10FFh  ; above
ParamTable_02   label   byte   ; H:S  Capa    Ortho SCSI[h
                DW      0820h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      0880h  ; < 61440MB
                DW      0880h  ; < 64GB
                DW      0880h  ; < 122GB
                DW      0880h  ; above
ParamTable_03   label   byte   ; H:S  Capa    SCSIRIFC-USP/UPg[h
                DW      0820h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      0F80h  ; < 61440MB
                DW      0FFFh  ; < 64GB
                DW      0FFFh  ; < 122GB
                DW      0FFFh  ; above
ParamTable_04   label   byte   ; H:S  Capa    SCSI SSDœKg[h
                DW      0820h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      1080h  ; < 61440MB
                DW      1080h  ; < 64GB
                DW      1080h  ; < 122GB
                DW      1080h  ; above
ParamTable_05   label   byte   ; H:S  Capa    SCSI SSD[h
                DW      0811h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      1080h  ; < 61440MB
                DW      1080h  ; < 64GB
                DW      10FFh  ; < 122GB
                DW      10FFh  ; above
if 1
ParamTable_06   label   byte   ; H:S  Capa    䃂[h
                DW      0811h  ; < 4351MB
                DW      103Fh  ; < 8192MB
                DW      103Fh  ; < 32255MB
                DW     0103Fh  ; < 32768MB
                DW     0103Fh  ; < 61440MB
                DW     0103Fh  ; < 64GB
                DW     0103Fh  ; < 122GB
                DW     0103Fh  ; above
endif
SetParaMode     ENDP


;----------------------------------------------------------------------
;       ModeCheck   
;----------------------------------------------------------------------
ModeCheck      PROC    near
                push    es

                mov     dx,891Eh
                in      al,dx
                and     al,00000111b    ; Mask higher bits

;;;             push    ax
;;;             call    digitx2
;;;             pop     ax
;;;              mov     dx,offset msg_CRLF
;;;              call    _puts

                cmp     al,7            ; ftHglV(111b)H
                jne     ClearBitAll     ; łȂ΂̂܂܎g
                mov     al,DefaultValueDSW  ; V̂Ƃ̑֒lDefaultValueDSW
ClearBitAll:    mov     ah,0            ; ʃoCg͎gpȂ

                push    ax
                mov     bx, offset ModeFlagFixed       ; ̕ϐ̃ItZbg
                sub     bx,2000h      ; bx=4c          ; 2000hȂ̂
                mov     ax,offset patch_program_base   ; ̃vO
                add     bx,ax                          ; ItZbgɏC
                pop     ax

                mov     cs:[bx],AL      ; gR[h
                mov     ModeID,AL       ; [J ALǂɂۑ
;                mov     AL,CF4351_flag
;                mov     cs:[bx+1],AL    ; gR[hɕۑ
                pop     es
                ret
ModeCheck      ENDP

;----------------------------------------------------------------------
;       DisplayStatus
;----------------------------------------------------------------------
DisplayStatus   PROC    near
                mov     dx,offset msg_DIPSW8C1E
                call    _puts

                mov     al,ModeID
                mov     ah,0

                push    ax
                 mov     ah,0
                 inc     ax
                 mov     al,1
                 jae     safevalue
                 mov     al,6
                 jbe     safevalue
                 mov     al,06h
                 out 37h,al
                 mov     al,0
safevalue:
                pop     ax

                shl     ax,1
                mov     bx,offset ParaMsgBase
                add     bx,ax
                mov     dx,ds:[bx]
                call    _puts           ; [hl̕񂩂\
                RET

mode1   DB      0E1h,"EXIDE(M9)[h(32255MBȏ16:255)",13,10,0
mode2   DB      0E1h,"SCSI EXIDE݃[h(SCSI4.3GB`32GB)",13,10,0
mode3   DB      0E1h,"SCSI S݊[h(32GBȏ؂̂)",13,10,0
mode4   DB      0E1h,"SCSI ٺg[h(32GBȏ,IFC-USP 1.20݊)",13,10,0
mode5   DB      0E1h,"SCSI SSDg[h(32GB`64GBƎ)",13,10,0
mode6   DB      0E1h,"SCSI SSD݃[h(4.3GBIDE݊)",13,10,0
mode7   DB      0E1h,"V_g[hi4.3GBЯĂȂ@튮S݊)",13,10,0
msg_DIPSW8C1E   DB      0E1h,"p[^[hF",0
ParaMsgBase     label   word
                DW      offset mode1
                DW      offset mode2
                DW      offset mode3
                DW      offset mode4
                DW      offset mode5
                DW      offset mode6
                DW      offset mode7
                DW      offset mode7
DisplayStatus   ENDP

;----------------------------------------------------------------------
;       DisplayBoardAddr  
;----------------------------------------------------------------------
DisplayBoardAddr  PROC    near
                mov     ax,COLUMN
                push    ax
                mov     ax,ROW
                push    ax
                inc     ax
                inc     ax
ifNdef  PCIROM
                mov     ROW,0
ifdef PCIROM
                mov     COLUMN,80-35
                mov     dx,offset location_msg
                call    _puts
else
                mov     COLUMN,80-6
endif
                mov     ax,cs:[00F8h]
                call    digitx
ENDIF
                pop     ax
                mov     ROW,ax
                pop     ax
                mov     COLUMN,ax
                RET
DisplayBoardAddr  ENDP
;----------------------------------------------------------------------

if 0
;------------------------------------------------------------------------
;       ResoModeCheckES esT-VRAMZOg, ϐ HiresoFlag,SegTVRAM
;------------------------------------------------------------------------
ResoModeCheckES PROC    near
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]           ; hi-reso check
                test    al,8
                jnz     HighResolutionMode
; Start Graphics
;               mov     HiresoFlag,0            ; high/low resolution mode flag
                mov     ax,0A000h
                jmp     CheckModeEnd
HighResolutionMode:
                mov     HiresoFlag,1            ; high/low flag
                mov     ax,0E000h
CheckModeEnd:   mov     es,ax
                mov     SegTVRAM,ax
                ret
ResoModeCheckES ENDP
endif


;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
LoopPressShift: mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     LoopPressShift
                ret
ShiftKeyCheck   ENDP

;--------------------------------------------------------
;       GetDisplayLine  ͏ɐ񖳂
;--------------------------------------------------------
MSG_DISP_LINE   equ     10
GetDisplayLine  PROC    near
                mov     es,SegTVRAM     ; 2018-12-8
                xor     ax,ax
                mov     ROW,MSG_DISP_LINE
                mov     COLUMN,ax
                mov     bx,3FE0h  ; Address of the current display line indicator
                mov     al,es:[bx]
                cmp     al,MSG_DISP_LINE
                ja      LineIndicatorInvalid
                inc     ax
                mov     ROW,ax
ifNdef MUTEING
                add     ax,4    ; 4s\s\񂷂
endif
                mov     es:[bx],al
LineIndicatorInvalid:
                ret
GetDisplayLine  ENDP


;--------------------------------------------------------------------
;       scan_pattern     ̔r[`    for IDE BIOS 
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern     PROC    near
                mov     di,0040h
                sub     cx,si
                mov     dx,2000h-40h
                sub     dx,cx
                cld

                xor     bx,bx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern     ENDP

ifdef PCIROM
ifNdef  PCIBIOS_PAT_INLINE
location_msg    DB      0E1h,"EXIDE{[h̾ıڽ = ",0
endif
endif

;------ moved from xa7cwpat.inc
space_otesu     DB      "萔";""
space_otesu_end label byte

;------ moved from xa13wpat.inc
space_nec       label   byte
                DB   "NEC Corp" ;"oration"
space_nec_end   label   byte

space_conner    label byte
                DB   "Conner Peri" ;"pherals"
space_conner_end label byte

space44         label   byte
                DB      44 dup(0)
space44_end     label   byte


dmy             DD      0EEEEEEEEh
