;       ds=7000h
;       es=5000h
;       
Ra300_patch     PROC    near
                cld
; Func_A  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                mov     si,offset CodePtnA1_Ra
                mov     cx,offset CodePtnA1_Ra_end
                call    scan_pattern
                jc      BIOS_not_Ra300
                mov     di,bx
                mov     si,offset PatPtnA1_Ra
           rep  movsb

                mov     si,offset CodePtnA2_Ra
                mov     cx,offset CodePtnA2_Ra_end
                call    scan_pattern
                jc      BIOS_not_Ra300
                mov     di,bx
                mov     si,offset PatPtnA2_Ra
           rep  movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Func_S 
                mov     si,offset CodePtnS_Ra
                mov     cx,offset CodePtnS_Ra_end
                call    scan_pattern
                jc      BIOS_not_Ra300
                mov     di,bx
                mov     si,offset PatPtnS_Ra
           rep  movsb
                clc
                ret
BIOS_not_Ra300:
                stc
                ret
Ra300_patch     ENDP

;------------------------------------------------------------
;       pb`ĂׂR[hp^[`PE`Q
;------------------------------------------------------------
CodePtnA1_Ra    label   byte
                cmp     byte ptr es:[bx+07h],11h     ; 11h=sector count
                jnz     $+2+1Eh  ; if S0==11h  exec Ini-Dev-Para command
                mov     byte ptr es:[2000h],07h ; [CMD] Initialize d-parameter
                mov     byte ptr es:[2001h],00h
                mov     byte ptr es:[200Ah],11h ; with 17 sectors
CodePtnA1_Ra_end label   byte

CodePtnA2_Ra    label   byte
                or      byte ptr es:[2004h],07h ; with 8 heads
CodePtnA2_Ra_end label   byte
;------------------------------------------------------------
;       ̏CR[h`PE`Q
;------------------------------------------------------------
PatPtnA1_Ra     label   byte
                mov     word ptr es:[2000h],0007h ; CMD] Ƽײ޲Ұ ܰޕ
                mov     al,byte ptr es:[bx+07h] ; BIOS sector
                mov     ah,byte ptr es:[bx+0Ah] ; BIOS headaxɈU[h
                mov     byte ptr es:[200Ah],al  ; sectorwork
                dec     ah                      ; head1
                nop
                nop
                DB      90h,90h,90h,90h,90h,90h         ; oCg킹

PatPtnA2_Ra     label   byte
                or      byte ptr es:[2004h],AH  ; ߑł7(8)ł͂Ȃhead
                nop                             ; oCg킹

;------------------------------------------------------------
;       pb`ĂׂR[hp^[r
;------------------------------------------------------------
CodePtnS_Ra     label   byte
                mov     ax,es:[di+0Ch]  ; foCX S
                xchg    ah,al           ; ٴި݂
                mov     cx,es:[di+06h]  ; foCX H
                xchg    ch,cl           ; ٴި݂
                mul     cx              ; (dx):ax=ax*cx
                mov     cx,es:[di+02h]  ; foCX V_
                xchg    ch,cl           ; ٴި݂
                mul     cx              ; dx:ax=ax*cx LBA𓾂
                cmp     dx,0088h        ; LBA17*8*6553616bit݂
                jnb     OFFSET_0B76     ; L[Ȃ[4352MBȏ]
                mov     cx,0088h        ; 17sect * 8 head ɋ
                div     cx              ; ߂ɊZ LBAdx:ax(17*8)
                mov     es:[bx],ax      ;  V_AX
                jmp     OFFSET_0B9C     ; 4.3GB over/underǂꍇI
OFFSET_0B76:                            ; ɗ̂ 4352MBȏ̂Ƃ
                mov     es:[bx],cx      ; foCXV_̂܂
                mov     ax,es:[di+0Ch]  ; foCX̂܂
                mov     cx,es:[di+06h]  ; foCXͯސ̂܂
                cmp     al,00           ; ZN^8[? 
                jnz     $+2+28h         ; łȂ΃G[
                cmp     cl,00           ; wb_8[? 255ͯނɂłȂIcO
                jnz     $+2+23h         ; łȂ΃G[
                xchg    ah,al           ; ٴި݂
                mov     es:[bx+07h],al  ; foCXZN^
                xchg    ch,cl           ; ٴި݂
                mov     es:[bx+0Ah],cl  ; foCXwbh
                mul     cx              ; AX=
                mov     es:[bx+08h],ax  ; H*Sςi[
OFFSET_0B9C:                            ; 4.3GB over/underǂꍇ
CodePtnS_Ra_end label   byte
;------------------------------------------------------------
;       CR[hr
;------------------------------------------------------------
PatPtnS_Ra      label   byte            ; CR[h
                mov     ax,es:[di+0Ch]  ; foCX S
                xchg    ah,al           ; ٴި݂
                mov     cx,es:[di+06h]  ; foCX H
                xchg    ch,cl           ; ٴި݂
                mul     cx
                mov     cx,es:[di+02h]  ; foCX V_
                xchg    ch,cl
                mul     cx
                cmp     dx,0088h
;;;;;;;                jnb short  $+2+0Ah         ; ρȂꍇ VҰ̏
             JMP short  $+2+0Ah         ; ρȂꍇ VҰ̏
                mov     cx,0088h        ; sȂuĂ
                div     cx              ; sȂuĂ
                mov     es:[bx],ax      ; sȂuĂ
                jmp     $+2+26h         ; 4.3GB over/underǂꍇI
; call far gR[  ; DX:AXC*H*SLBA,  CH=wbh , CL=ZN^
                DB 9Ah ; CALL far       ; gR[h̏֔
                DW      offset Ra300_SetCHS ; DI,BXKۑ,DX,AX,CX͓K؂ɕύX

                DW      MEMseg
;               ̎_; DX:AX=LBA,  CH=wbh , CL=ZN^
                push    ax
                mov     al,ch           ; Ẑ߃wbhALɈڂ
                mov     es:[bx+07h],cl  ; BIOSZN^
                mov     es:[bx+0Ah],al  ; BIOSwbh
                mul     cl              ; ܂AXH*Sς𓾂
                mov     es:[bx+08h],ax  ; BIOS H*Sςۑ
                mov     cx,ax           ; ƂĎĝ H*SςCXɈڂ
                pop     ax              ; Ƃ DX:AXɕA
                div     cx              ; LBA(H*S)
                mov     es:[bx],ax      ; ŃV_ axɓAۑ
                nop                     ; oCg킹
                nop
                DB      8  dup (90h)
PatPtnS_Ra_end  label   byte

; Ql ԐڎQƏꏊ   e
;2100  es:[BX    ]  (W) BIOS cylinder
;2107  es:[BX+07h]  (B) BIOS sector
;2108  es:[BX+08h]  (W) BIOS sector*head
;210A  es:[BX+0Ah]  (B) BIOS head
